# 框架文档
## 模型
### 查询
    UserFacade::getModel()->buildQuery([
        'user_name' => 'zmx',
        'nick_name' => [['like','zhuang'],['in',['zmx','zhuang123']],['<>','1234']],
        '_string'   => 'status=0 and company_id=1'
    ])->selectRaw('id,user_id,user_name,nick_name')->get();
执行后的sql：select id,user_id,user_name,nick_name from user where user_name='zmx' and nick_name like '%zhuang%' and nick_name in ('zmx','zhuang123') and nick_name<>'1234' and status=0 and company_id=1

buildQuery 只支持Model调用，不支持 `DB::table('company_user')->buildQuery([])`
### 根据主键直接获取单条记录
    UserFacade::findOneById(1,'id,user_id,user_name,nick_name')
### 根据条件获取单条记录
    UserFacade::findOneBy(['user_name'=>'zmx'],'id,user_id,nick_name')
### 根据条件查询获取多条记录
    UserFacade::findBy(['user_name'=>'zmx'],'id,user_id,nick_name')
### 使用原生SQL查询
    UserFacade::query('select * from company_user where id=1')
### 获取某个字段值
    UserFacade::getFieldBy('nick_name',['user_name'=>'zmx'])    
### 获取数据模型
    UserFacade::getModel()
### 获取Table名称
    UserFacade::getTable()
### 验证字段值是否唯一
    UserFacade::checkFieldUnique('user_name','zmx',['id'=>[
        ['notIn',[12]]
    ]])
### 新增记录
    UserFacade::save(['user_name'=>'zmx','nick_name'=>'zmx'])
### 新增多条记录
    UserFacade::saveAll([
        ['user_name'=>'zmx','nick_name'=>'zmx'],
        ['user_name'=>'yunnan','nick_name'=>'yunnan']
    ])
### 更新记录
    UserFacade::update(1,['user_name'=>'zmx','nick_name'=>'zhuang123'])
### 根据条件更改记录
    UserFacade::updateBy(['user_name'=>'zmx'],['nick_name'=>'zhuang234'])
### 删除记录
    UserFacade::delete(1)
### 根据条件删除记录
    UserFacade::deleteBy(['user_name'=>'zmx'])
### 软删除
    class UserModel extends BaseModel {
        use ApiSoftDeletes;
        protected $table = 'company_user'; //表名
        protected $hidden = ['password']; //格式化成json时隐藏的字段
        protected $casts = [
            'permissions' => 'array', //该字段自动格式化成数组
            'role_id'   => 'int'    //该字段自动格式化成整形
        ];
        const STATUS_ENABLED = 1; //定义软删除字段status为正常使用
        const STATUS_DELETED = 2; //定义软删除字段status为删除状态
        const STATUS_DISABLED = 3; //定义软删除字段status为禁用状态
    }
添加软删除后，在查询时 UserFacade::findOneById(1) 会自动添加 status=1 的条件

如果要查询出所有状态值得数据需使用 `UserModel::where('id',1)->withAll()->first()`


##创建模块
    php artisan module moduleName
moduleName：模块名

##创建模型文件
    php artisan make:tpl moduleName ActionName
moduleName：模块名

actionName：文件名称

例：php artisan make:tpl User CompanyUser

以上命令会再User目录下的Facades、Services、Models新建CompanyUser对应的类，已经存在的文件不会再创建，但provider需要手动处理
## 不能使用的路由
```
/dist
/static
/sitemap
```
